#include "Geometry.h"

Geometry::Geometry(KFbxNode *root) {
//	mRoot = new Mesh(root, NULL);
	mMeshes.resize(0);
	mMeshes.push_back(new Mesh(root));

	addAllChildren(root, NULL);


}
Geometry::~Geometry() {

//	delete mRoot;
	for (unsigned int i = 0; i < mMeshes.size(); i++) {
		delete mMeshes[i];
	}
}

vector<Mesh *> Geometry::getMeshes() {
	return mMeshes;
}

void Geometry::addAllChildren(KFbxNode *node, Mesh *parent) {
	for (int i = 0; i < node->GetChildCount(); i++) {
		KFbxNode *currNode = node->GetChild(i);
		Mesh *currMesh = NULL;
		const char *n=currNode->GetName();
		// it's a mesh object
		if (currNode->GetNodeAttribute()->GetAttributeType() == KFbxNodeAttribute::eMESH) {
			currMesh = new Mesh(currNode);
//			parent->addChild(currMesh);
			mMeshes.push_back(currMesh);
		}
		// search children
		if (currMesh == NULL) {
				addAllChildren(currNode, parent); // don't include this parent, as it's not a mesh

		} else {
			addAllChildren(currNode, currMesh);
		}
	}

}

void Geometry::print() {
//	printf("%s\n", mRoot->getName());
//	vector<Mesh *>c = mRoot->getChildren();
	for (unsigned int i = 0; i < mMeshes.size(); i++) {
		printf("%s\n", mMeshes[i]->getName());

	}
}
/*void Geometry::print(Mesh *p, int depth) {
	for (int i = 0; i < depth; i++) {
		printf("\t");
	}

	printf("%s\n", p->getName());
	vector<Mesh *>c = p->getChildren();
	for (unsigned int i = 0; i < c.size(); i++) {
		print(c[i], depth+1);

	}
	
}*/