#ifndef __VERTEX__
#define __VERTEX__


struct Vertex {

	// coordinates
	float x, y, z;
	// normals
	float nx, ny, nz;
	// texture coordinates
	float u, v;
};

struct Polygon {
	int vertexCount;
	Vertex *vertices;
	// colors
	float r, g, b;
	// reflection
	float reflection;
	// refraction (transmission);
	float refraction;
	// index of refraction
	float indexOfRefraction;
};
// compute cross product, assumes v has 3 or more vertices
void cross(Vertex v[], float &xn, float &yn, float &zn);

// deep copies
void vertexCopy(Vertex &out, Vertex &in);
void polygonCopy(Polygon &out, Polygon &in);

// "fix" vertex normals by making them perpendicular to polygon
void fixNormals(Polygon *p);

#endif