/*
 * camera class, holds all data about camera

 */

#ifndef __CAMERA_H
#define __CAMERA_H

#include <stdlib.h> 
#include <stdio.h>
#include <GL/glew.h>
#include <GL/glut.h>
#include <cuda_runtime_api.h>
#include <cuda_gl_interop.h>
#include <cutil.h>


class Camera {

public:
	Camera();
	Camera(float3 pos, float3 mLookAt, float3 up);
	~Camera();


	void setPos(float3 pos);
	void setLookAt(float3 lookAt);
	void setUp(float3 up);

	float3 getPos();
	float3 getLookAt();
	float3 getUp();

	// move functions
	void moveX(float dx);
	void moveY(float dy);
	void moveZ(float dz);
	void moveForward(float dz);
	void moveSideways(float dx);

	// rotate functions
	void pitch(float dy);
	void rotateY(float dy);
	void rotateZ(float dz);

private:
	float3 mPos;
	float3 mLookAt;
	float3 mUp;

	float mXAngle;
	float mYAngle;

};

#endif